.386
.model flat, stdcall
option casemap :none
include macro.inc
include \MASM32\INCLUDE\windows.inc
LIB  gdi32,user32,kernel32,comctl32
LIB comdlg32,masm32,perso32,shell32,htmlhelp,ole32,winmm

	HIWORD MACRO ParamFen
		mov eax,ParamFen
		shr eax,16
	ENDM
	LOWORD MACRO ParamFen
		mov eax,ParamFen
		and eax,0FFFFh
	ENDM
	FRECT	STRUCT
		min POINT <>
		max POINT <>
	FRECT ENDS	
	MAKELONG MACRO ARG1:REQ,ARG2:REQ
		mov edx,ARG2
		shl edx,16
		add edx,ARG1
	ENDM

WinMain      PROTO
WndProc      PROTO :DWORD,:DWORD,:DWORD,:DWORD

.const
ID_BTN1      equ 600
ID_BTN2      equ 601

.data
szClassName    db "WinClass",0
szProgramName  db "ToolTip Window",0
szButtonClass  db "BUTTON",0
szToolTipClass db "tooltips_class32",0
szBtnTxt1      db "Activate",0
szBtnTxt2      db "square rotate",0
szToolTxt1     db "SAR Shifts the destination right by 'count' bits with the current sign bit replicated in the leftmost bit.  The Carry Flag contains the last bit shifted out",0

wc WNDCLASSEX<sizeof WNDCLASSEX,\
		CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW,\
		offset WndProc,NULL,NULL,NULL,0,0,COLOR_BTNFACE+1,\
		NULL,offset szClassName,0>
ti TOOLINFO<>
;CS_HREDRAW or CS_VREDRAW or 
hInstance     dd 0
hWnd          dd 0
hButton1      dd 0
hButton2      dd 0
hToolTip      dd 0
square        db 1
NewCommonStr INITCOMMONCONTROLSEX <>
.code
	start:
	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	mov       NewCommonStr.dwSize,sizeof NewCommonStr
	mov 	   NewCommonStr.dwICC,ICC_COOL_CLASSES or ICC_USEREX_CLASSES or ICC_BAR_CLASSES \
			or ICC_TAB_CLASSES or ICC_WIN95_CLASSES or ICC_LISTVIEW_CLASSES 
	
	invoke     InitCommonControlsEx ,addr NewCommonStr ; InitCommonControl	
	invoke InitCommonControls
	invoke WinMain
	invoke ExitProcess,eax

;==========================================================================

WinMain proc
	LOCAL msg:MSG

	push   hInstance
	pop    wc.hInstance
	invoke LoadCursor,NULL,IDC_ARROW
	mov    wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	;CENTER THE PROGRAM WINDOW
	invoke GetSystemMetrics,SM_CXSCREEN
	mov    esi,eax
	invoke GetSystemMetrics,SM_CYSCREEN
	mov    ecx,eax
	shr    esi,1
	shr    ecx,1
	sub    esi,500/2
	sub    ecx,300/2
	;CREATE THE PROGRAM WINDOW
	invoke CreateWindowEx,WS_EX_LEFT,addr szClassName,addr szProgramName,
		WS_VISIBLE or WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS,esi,ecx,500,300,NULL,NULL,
		hInstance,NULL
	mov    hWnd,eax
	;MESSAGE LOOP
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
		.break .if (!eax)
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov    eax,msg.wParam
	ret

WinMain endp

;==========================================================================

WndProc proc uses ebx hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	LOCAL rect:FRECT
	LOCAL Largeur:DWORD,Hauteur

	.if    uMsg == WM_CREATE
		;CREATE BUTTONS
		invoke CreateWindowEx,NULL,addr szButtonClass,addr szBtnTxt1,
			WS_CHILD or WS_VISIBLE,10,10,100,30,hWin,ID_BTN1,hInstance,NULL
		mov    hButton1,eax
		invoke CreateWindowEx,NULL,addr szButtonClass,addr szBtnTxt2,
			WS_CHILD or WS_VISIBLE,210,10,100,30,hWin,ID_BTN2,hInstance,NULL
		mov    hButton2,eax
		;CREATE TOOLTIP
		invoke CreateWindowEx,WS_EX_TOPMOST,addr szToolTipClass,NULL,
			WS_POPUP or TTS_NOPREFIX or TTS_BALLOON,0,0,0,0,hWin,NULL,hInstance,NULL
		mov    hToolTip,eax
		invoke SetWindowPos,hToolTip,HWND_TOPMOST,0,0,0,0,
			SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE
		;INITIALIZE MEMBERS OF THE TOOLINFO STRUCTURE
		mov    ti.cbSize,sizeof TOOLINFO
		mov    ti.uFlags,TTF_IDISHWND or TTF_TRACK or TTF_ABSOLUTE 
		push   hWin
		pop    ti.hWnd
		push   hInstance
		pop    ti.hInst
		push   hButton1
		pop    ti.uId
		mov    ti.lpszText,offset szToolTxt1
		;SEND AN ADDTOOL MESSAGE TO THE TOOLTIP CONTROL WINDOW
		invoke SendMessage,hToolTip,TTM_ADDTOOL,0,addr ti
		mov edx,300	;y	in screen coordinate
		shl edx,16
		add edx,400 ;x
		;fix the position
		invoke SendMessage,hToolTip,TTM_TRACKPOSITION,0,edx	
		;deactivate the tooltip
		invoke SendMessage,hToolTip,TTM_TRACKACTIVATE,FALSE,addr ti
		;Sets the maximum width for a ToolTip window,text is break at space
		invoke SendMessage,hToolTip,TTM_SETMAXTIPWIDTH,0,400

	.elseif uMsg == WM_COMMAND
		HIWORD wParam		;evenements des listbox ,combo sont ici
		mov edx,eax		;exemple :TCN_SELCHANGE
		LOWORD wParam		;IDentificateurs de  commandes eax
		mov ebx,lParam	; handle du controle
		;suite	
		xor eax,eax 	;la valeur de retour
		.if ebx == hButton1
			invoke SendMessage,hToolTip,TTM_TRACKACTIVATE,TRUE,addr ti
		.elseif ebx == hButton2
			;invoke SendMessage,hToolTip,TTM_TRACKACTIVATE,FALSE,addr ti
			;modify the position of the tooltip
			invoke GetClientRect,hWin,addr rect
			mov eax,rect.max.x
			mov Largeur,eax
			mov eax, rect.max.y
			mov  Hauteur,eax
			;point zero zero (min) in screen coordinate
			invoke ClientToScreen,hWin,addr rect.min
			;------- the tooltip made a square rotate
			.if square == 1
				;top left
				mov edx,rect.min.y
				add edx,50		;aproximate the height of button + margins
				shl edx,16								
				mov eax,rect.min.x
				add eax,20											
				add edx,eax
				invoke SendMessage,hToolTip,TTM_TRACKPOSITION,0,edx					
			.elseif square == 2
				;top right
				mov edx,rect.min.y
				add edx,50		;aproximate the height of button + margins
				shl edx,16								
				mov eax,rect.min.x
				add eax,Largeur
				sub eax,20															
				add edx,eax
				invoke SendMessage,hToolTip,TTM_TRACKPOSITION,0,edx									
			.elseif square == 3
				;low right
				mov edx,rect.min.y
				add edx,Hauteur		;aproximate the height of button + margins
				sub edx,20
				shl edx,16								
				mov eax,rect.min.x
				add eax,Largeur
				sub eax,20											
				add edx,eax
				invoke SendMessage,hToolTip,TTM_TRACKPOSITION,0,edx									
				
			.elseif square == 4
				;low left
				mov edx,rect.min.y
				add edx,Hauteur		;aproximate the height of button + margins
				sub edx,20
				shl edx,16								
				mov eax,rect.min.x
				add eax,20											
				add edx,eax
				invoke SendMessage,hToolTip,TTM_TRACKPOSITION,0,edx									
			.endif
			inc square
			.if square == 5
				mov square,1
			.endif
			
		.endif	

	.elseif uMsg == WM_DESTROY
		invoke PostQuitMessage,NULL
		xor    eax,eax
		ret
	.endif
	invoke DefWindowProc,hWin,uMsg,wParam,lParam
	ret

WndProc endp

;==========================================================================

end start

